/* FileItem.c generated by valac 0.48.19, the Vala compiler
 * generated from FileItem.vala, do not modify */

/*
 * FileItem.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define TYPE_FILE_ITEM (file_item_get_type ())
#define FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_ITEM, FileItem))
#define FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_ITEM, FileItemClass))
#define IS_FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_ITEM))
#define IS_FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_ITEM))
#define FILE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_ITEM, FileItemClass))

typedef struct _FileItem FileItem;
typedef struct _FileItemClass FileItemClass;
typedef struct _FileItemPrivate FileItemPrivate;
enum  {
	FILE_ITEM_0_PROPERTY,
	FILE_ITEM_SIZE_PROPERTY,
	FILE_ITEM_NUM_PROPERTIES
};
static GParamSpec* file_item_properties[FILE_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _FileItem {
	GObject parent_instance;
	FileItemPrivate * priv;
	gchar* file_name;
	gchar* file_location;
	gchar* file_path;
	gchar* file_path_prefix;
	GFileType file_type;
	GDateTime* modified;
	gchar* permissions;
	gchar* owner_user;
	gchar* owner_group;
	gchar* content_type;
	gchar* file_status;
	gboolean is_selected;
	gboolean is_symlink;
	gchar* symlink_target;
	glong file_count;
	glong dir_count;
	GIcon* icon;
};

struct _FileItemClass {
	GObjectClass parent_class;
};

struct _FileItemPrivate {
	gint64 _size;
};

static gint FileItem_private_offset;
static gpointer file_item_parent_class = NULL;
static GeeComparableIface * file_item_gee_comparable_parent_iface = NULL;

GType file_item_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileItem, g_object_unref)
FileItem* file_item_new (const gchar* name);
FileItem* file_item_construct (GType object_type,
                               const gchar* name);
FileItem* file_item_new_from_disk_path_with_basic_info (const gchar* _file_path);
FileItem* file_item_construct_from_disk_path_with_basic_info (GType object_type,
                                                              const gchar* _file_path);
gchar* tee_jee_file_system_file_basename (const gchar* file_path);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
void file_item_query_file_info_basic (FileItem* self);
FileItem* file_item_new_from_path_and_type (const gchar* _file_path,
                                            GFileType _file_type);
FileItem* file_item_construct_from_path_and_type (GType object_type,
                                                  const gchar* _file_path,
                                                  GFileType _file_type);
static gint file_item_real_compare_to (GeeComparable* base,
                                FileItem* b);
void file_item_query_file_info (FileItem* self);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
GdkPixbuf* file_item_get_icon (FileItem* self,
                               gint icon_size,
                               gboolean add_transparency,
                               gboolean add_emblems);
GdkPixbuf* icon_manager_lookup_gicon (GIcon* gicon,
                                      gint icon_size);
GdkPixbuf* icon_manager_lookup (const gchar* icon_name,
                                gint icon_size,
                                gboolean symbolic,
                                gboolean use_hardcoded,
                                gint scale);
gint64 file_item_get_size (FileItem* self);
static void file_item_finalize (GObject * obj);
static GType file_item_get_type_once (void);
static void _vala_file_item_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
file_item_get_instance_private (FileItem* self)
{
	return G_STRUCT_MEMBER_P (self, FileItem_private_offset);
}

FileItem*
file_item_construct (GType object_type,
                     const gchar* name)
{
	FileItem * self = NULL;
	gchar* _tmp0_;
#line 63 "Utility/FileItem.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 63 "Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 64 "Utility/FileItem.vala"
	_tmp0_ = g_strdup (name);
#line 64 "Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 64 "Utility/FileItem.vala"
	self->file_name = _tmp0_;
#line 63 "Utility/FileItem.vala"
	return self;
#line 156 "FileItem.c"
}

FileItem*
file_item_new (const gchar* name)
{
#line 63 "Utility/FileItem.vala"
	return file_item_construct (TYPE_FILE_ITEM, name);
#line 164 "FileItem.c"
}

FileItem*
file_item_construct_from_disk_path_with_basic_info (GType object_type,
                                                    const gchar* _file_path)
{
	FileItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 67 "Utility/FileItem.vala"
	g_return_val_if_fail (_file_path != NULL, NULL);
#line 67 "Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 68 "Utility/FileItem.vala"
	_tmp0_ = g_strdup (_file_path);
#line 68 "Utility/FileItem.vala"
	_g_free0 (self->file_path);
#line 68 "Utility/FileItem.vala"
	self->file_path = _tmp0_;
#line 69 "Utility/FileItem.vala"
	_tmp1_ = tee_jee_file_system_file_basename (_file_path);
#line 69 "Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 69 "Utility/FileItem.vala"
	self->file_name = _tmp1_;
#line 70 "Utility/FileItem.vala"
	_tmp2_ = tee_jee_file_system_file_parent (_file_path);
#line 70 "Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 70 "Utility/FileItem.vala"
	self->file_location = _tmp2_;
#line 71 "Utility/FileItem.vala"
	file_item_query_file_info_basic (self);
#line 67 "Utility/FileItem.vala"
	return self;
#line 201 "FileItem.c"
}

FileItem*
file_item_new_from_disk_path_with_basic_info (const gchar* _file_path)
{
#line 67 "Utility/FileItem.vala"
	return file_item_construct_from_disk_path_with_basic_info (TYPE_FILE_ITEM, _file_path);
#line 209 "FileItem.c"
}

FileItem*
file_item_construct_from_path_and_type (GType object_type,
                                        const gchar* _file_path,
                                        GFileType _file_type)
{
	FileItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 74 "Utility/FileItem.vala"
	g_return_val_if_fail (_file_path != NULL, NULL);
#line 74 "Utility/FileItem.vala"
	self = (FileItem*) g_object_new (object_type, NULL);
#line 75 "Utility/FileItem.vala"
	_tmp0_ = g_strdup (_file_path);
#line 75 "Utility/FileItem.vala"
	_g_free0 (self->file_path);
#line 75 "Utility/FileItem.vala"
	self->file_path = _tmp0_;
#line 76 "Utility/FileItem.vala"
	_tmp1_ = tee_jee_file_system_file_basename (_file_path);
#line 76 "Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 76 "Utility/FileItem.vala"
	self->file_name = _tmp1_;
#line 77 "Utility/FileItem.vala"
	_tmp2_ = tee_jee_file_system_file_parent (_file_path);
#line 77 "Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 77 "Utility/FileItem.vala"
	self->file_location = _tmp2_;
#line 78 "Utility/FileItem.vala"
	self->file_type = _file_type;
#line 74 "Utility/FileItem.vala"
	return self;
#line 247 "FileItem.c"
}

FileItem*
file_item_new_from_path_and_type (const gchar* _file_path,
                                  GFileType _file_type)
{
#line 74 "Utility/FileItem.vala"
	return file_item_construct_from_path_and_type (TYPE_FILE_ITEM, _file_path, _file_type);
#line 256 "FileItem.c"
}

static gint
file_item_real_compare_to (GeeComparable* base,
                           FileItem* b)
{
	FileItem * self;
	GFileType _tmp0_;
	GFileType _tmp1_;
	gint result = 0;
#line 91 "Utility/FileItem.vala"
	self = (FileItem*) base;
#line 91 "Utility/FileItem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 92 "Utility/FileItem.vala"
	_tmp0_ = self->file_type;
#line 92 "Utility/FileItem.vala"
	_tmp1_ = b->file_type;
#line 92 "Utility/FileItem.vala"
	if (_tmp0_ != _tmp1_) {
#line 277 "FileItem.c"
		GFileType _tmp2_;
#line 93 "Utility/FileItem.vala"
		_tmp2_ = self->file_type;
#line 93 "Utility/FileItem.vala"
		if (_tmp2_ == G_FILE_TYPE_DIRECTORY) {
#line 94 "Utility/FileItem.vala"
			result = -1;
#line 94 "Utility/FileItem.vala"
			return result;
#line 287 "FileItem.c"
		} else {
#line 97 "Utility/FileItem.vala"
			result = 1;
#line 97 "Utility/FileItem.vala"
			return result;
#line 293 "FileItem.c"
		}
	} else {
		GCompareFunc _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gint _tmp10_;
#line 102 "Utility/FileItem.vala"
		_tmp3_ = ((GCompareFunc) g_strcmp0);
#line 102 "Utility/FileItem.vala"
		_tmp4_ = self->file_name;
#line 102 "Utility/FileItem.vala"
		_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 102 "Utility/FileItem.vala"
		_tmp6_ = _tmp5_;
#line 102 "Utility/FileItem.vala"
		_tmp7_ = b->file_name;
#line 102 "Utility/FileItem.vala"
		_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
#line 102 "Utility/FileItem.vala"
		_tmp9_ = _tmp8_;
#line 102 "Utility/FileItem.vala"
		_tmp10_ = _tmp3_ (_tmp6_, _tmp9_);
#line 102 "Utility/FileItem.vala"
		_g_free0 (_tmp9_);
#line 102 "Utility/FileItem.vala"
		_g_free0 (_tmp6_);
#line 102 "Utility/FileItem.vala"
		result = _tmp10_;
#line 102 "Utility/FileItem.vala"
		return result;
#line 328 "FileItem.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 130 "Utility/FileItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 337 "FileItem.c"
}

void
file_item_query_file_info (FileItem* self)
{
	GError* _inner_error0_ = NULL;
#line 112 "Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 346 "FileItem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
#line 116 "Utility/FileItem.vala"
		_tmp0_ = self->file_path;
#line 116 "Utility/FileItem.vala"
		_tmp1_ = g_file_parse_name (_tmp0_);
#line 116 "Utility/FileItem.vala"
		file = _tmp1_;
#line 118 "Utility/FileItem.vala"
		_tmp2_ = file;
#line 118 "Utility/FileItem.vala"
		if (g_file_query_exists (_tmp2_, NULL)) {
#line 363 "FileItem.c"
			GFileInfo* _tmp3_ = NULL;
			GFile* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileType item_file_type = 0;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			GIcon* _tmp12_;
			GIcon* _tmp13_;
			GFileType _tmp14_;
			GFileInfo* _tmp20_ = NULL;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			GFileInfo* _tmp24_;
			GFileInfo* _tmp25_;
			GFileInfo* _tmp26_;
			GFileInfo* _tmp30_;
			GFileInfo* _tmp31_;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			gboolean _tmp34_ = FALSE;
			GFileInfo* _tmp37_;
			GTimeVal _tmp38_ = {0};
			GDateTime* _tmp39_;
			GDateTime* _tmp40_;
			GDateTime* _tmp41_;
			GFileInfo* _tmp42_;
			const gchar* _tmp43_;
			gchar* _tmp44_;
			GFileInfo* _tmp45_;
			const gchar* _tmp46_;
			gchar* _tmp47_;
#line 122 "Utility/FileItem.vala"
			_tmp4_ = file;
#line 122 "Utility/FileItem.vala"
			_tmp5_ = g_strdup_printf ("%s,%s,%s", G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_ATTRIBUTE_STANDARD_ICON, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 122 "Utility/FileItem.vala"
			_tmp6_ = _tmp5_;
#line 122 "Utility/FileItem.vala"
			_tmp7_ = g_file_query_info (_tmp4_, _tmp6_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 122 "Utility/FileItem.vala"
			_tmp8_ = _tmp7_;
#line 122 "Utility/FileItem.vala"
			_g_free0 (_tmp6_);
#line 122 "Utility/FileItem.vala"
			_tmp3_ = _tmp8_;
#line 122 "Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "Utility/FileItem.vala"
				_g_object_unref0 (file);
#line 122 "Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 420 "FileItem.c"
				goto __catch0_g_error;
			}
#line 122 "Utility/FileItem.vala"
			_tmp9_ = _tmp3_;
#line 122 "Utility/FileItem.vala"
			_tmp3_ = NULL;
#line 122 "Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 122 "Utility/FileItem.vala"
			info = _tmp9_;
#line 128 "Utility/FileItem.vala"
			_tmp10_ = info;
#line 128 "Utility/FileItem.vala"
			item_file_type = g_file_info_get_file_type (_tmp10_);
#line 130 "Utility/FileItem.vala"
			_tmp11_ = info;
#line 130 "Utility/FileItem.vala"
			_tmp12_ = g_file_info_get_icon (_tmp11_);
#line 130 "Utility/FileItem.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 130 "Utility/FileItem.vala"
			_g_object_unref0 (self->icon);
#line 130 "Utility/FileItem.vala"
			self->icon = _tmp13_;
#line 132 "Utility/FileItem.vala"
			_tmp14_ = item_file_type;
#line 132 "Utility/FileItem.vala"
			if (_tmp14_ == G_FILE_TYPE_SYMBOLIC_LINK) {
#line 449 "FileItem.c"
				GFileInfo* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 134 "Utility/FileItem.vala"
				self->is_symlink = TRUE;
#line 135 "Utility/FileItem.vala"
				_tmp15_ = info;
#line 135 "Utility/FileItem.vala"
				_tmp16_ = g_file_info_get_symlink_target (_tmp15_);
#line 135 "Utility/FileItem.vala"
				_tmp17_ = g_strdup (_tmp16_);
#line 135 "Utility/FileItem.vala"
				_g_free0 (self->symlink_target);
#line 135 "Utility/FileItem.vala"
				self->symlink_target = _tmp17_;
#line 465 "FileItem.c"
			} else {
				gchar* _tmp18_;
				GFileType _tmp19_;
#line 139 "Utility/FileItem.vala"
				self->is_symlink = FALSE;
#line 140 "Utility/FileItem.vala"
				_tmp18_ = g_strdup ("");
#line 140 "Utility/FileItem.vala"
				_g_free0 (self->symlink_target);
#line 140 "Utility/FileItem.vala"
				self->symlink_target = _tmp18_;
#line 142 "Utility/FileItem.vala"
				_tmp19_ = item_file_type;
#line 142 "Utility/FileItem.vala"
				if (_tmp19_ == G_FILE_TYPE_REGULAR) {
#line 481 "FileItem.c"
				}
			}
#line 157 "Utility/FileItem.vala"
			_tmp21_ = file;
#line 157 "Utility/FileItem.vala"
			_tmp22_ = g_strdup_printf ("%s,%s,%s,%s,%s,%s,%s,%s", G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_ATTRIBUTE_STANDARD_ICON, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_ATTRIBUTE_OWNER_USER, G_FILE_ATTRIBUTE_OWNER_GROUP, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
#line 157 "Utility/FileItem.vala"
			_tmp23_ = _tmp22_;
#line 157 "Utility/FileItem.vala"
			_tmp24_ = g_file_query_info (_tmp21_, _tmp23_, 0, NULL, &_inner_error0_);
#line 157 "Utility/FileItem.vala"
			_tmp25_ = _tmp24_;
#line 157 "Utility/FileItem.vala"
			_g_free0 (_tmp23_);
#line 157 "Utility/FileItem.vala"
			_tmp20_ = _tmp25_;
#line 157 "Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "Utility/FileItem.vala"
				_g_object_unref0 (_tmp3_);
#line 157 "Utility/FileItem.vala"
				_g_object_unref0 (file);
#line 157 "Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 506 "FileItem.c"
				goto __catch0_g_error;
			}
#line 157 "Utility/FileItem.vala"
			_tmp26_ = _tmp20_;
#line 157 "Utility/FileItem.vala"
			_tmp20_ = NULL;
#line 157 "Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 157 "Utility/FileItem.vala"
			info = _tmp26_;
#line 168 "Utility/FileItem.vala"
			if (self->is_symlink) {
#line 519 "FileItem.c"
				GFileInfo* _tmp27_;
				GIcon* _tmp28_;
				GIcon* _tmp29_;
#line 170 "Utility/FileItem.vala"
				_tmp27_ = info;
#line 170 "Utility/FileItem.vala"
				_tmp28_ = g_file_info_get_icon (_tmp27_);
#line 170 "Utility/FileItem.vala"
				_tmp29_ = _g_object_ref0 (_tmp28_);
#line 170 "Utility/FileItem.vala"
				_g_object_unref0 (self->icon);
#line 170 "Utility/FileItem.vala"
				self->icon = _tmp29_;
#line 533 "FileItem.c"
			}
#line 174 "Utility/FileItem.vala"
			_tmp30_ = info;
#line 174 "Utility/FileItem.vala"
			self->file_type = g_file_info_get_file_type (_tmp30_);
#line 177 "Utility/FileItem.vala"
			_tmp31_ = info;
#line 177 "Utility/FileItem.vala"
			_tmp32_ = g_file_info_get_content_type (_tmp31_);
#line 177 "Utility/FileItem.vala"
			_tmp33_ = g_strdup (_tmp32_);
#line 177 "Utility/FileItem.vala"
			_g_free0 (self->content_type);
#line 177 "Utility/FileItem.vala"
			self->content_type = _tmp33_;
#line 180 "Utility/FileItem.vala"
			if (!self->is_symlink) {
#line 551 "FileItem.c"
				GFileType _tmp35_;
#line 180 "Utility/FileItem.vala"
				_tmp35_ = self->file_type;
#line 180 "Utility/FileItem.vala"
				_tmp34_ = _tmp35_ == G_FILE_TYPE_REGULAR;
#line 557 "FileItem.c"
			} else {
#line 180 "Utility/FileItem.vala"
				_tmp34_ = FALSE;
#line 561 "FileItem.c"
			}
#line 180 "Utility/FileItem.vala"
			if (_tmp34_) {
#line 565 "FileItem.c"
				GFileInfo* _tmp36_;
#line 181 "Utility/FileItem.vala"
				_tmp36_ = info;
#line 181 "Utility/FileItem.vala"
				self->priv->_size = g_file_info_get_size (_tmp36_);
#line 571 "FileItem.c"
			}
#line 185 "Utility/FileItem.vala"
			_tmp37_ = info;
#line 185 "Utility/FileItem.vala"
			g_file_info_get_modification_time (_tmp37_, &_tmp38_);
#line 185 "Utility/FileItem.vala"
			_tmp39_ = g_date_time_new_from_timeval_utc (&_tmp38_);
#line 185 "Utility/FileItem.vala"
			_tmp40_ = _tmp39_;
#line 185 "Utility/FileItem.vala"
			_tmp41_ = g_date_time_to_local (_tmp40_);
#line 185 "Utility/FileItem.vala"
			_g_date_time_unref0 (self->modified);
#line 185 "Utility/FileItem.vala"
			self->modified = _tmp41_;
#line 185 "Utility/FileItem.vala"
			_g_date_time_unref0 (_tmp40_);
#line 188 "Utility/FileItem.vala"
			_tmp42_ = info;
#line 188 "Utility/FileItem.vala"
			_tmp43_ = g_file_info_get_attribute_string (_tmp42_, G_FILE_ATTRIBUTE_OWNER_USER);
#line 188 "Utility/FileItem.vala"
			_tmp44_ = g_strdup (_tmp43_);
#line 188 "Utility/FileItem.vala"
			_g_free0 (self->owner_user);
#line 188 "Utility/FileItem.vala"
			self->owner_user = _tmp44_;
#line 191 "Utility/FileItem.vala"
			_tmp45_ = info;
#line 191 "Utility/FileItem.vala"
			_tmp46_ = g_file_info_get_attribute_string (_tmp45_, G_FILE_ATTRIBUTE_OWNER_GROUP);
#line 191 "Utility/FileItem.vala"
			_tmp47_ = g_strdup (_tmp46_);
#line 191 "Utility/FileItem.vala"
			_g_free0 (self->owner_group);
#line 191 "Utility/FileItem.vala"
			self->owner_group = _tmp47_;
#line 118 "Utility/FileItem.vala"
			_g_object_unref0 (_tmp20_);
#line 118 "Utility/FileItem.vala"
			_g_object_unref0 (_tmp3_);
#line 613 "FileItem.c"
		}
#line 114 "Utility/FileItem.vala"
		_g_object_unref0 (file);
#line 114 "Utility/FileItem.vala"
		_g_object_unref0 (info);
#line 619 "FileItem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp48_;
		const gchar* _tmp49_;
#line 114 "Utility/FileItem.vala"
		e = _inner_error0_;
#line 114 "Utility/FileItem.vala"
		_inner_error0_ = NULL;
#line 196 "Utility/FileItem.vala"
		_tmp48_ = e;
#line 196 "Utility/FileItem.vala"
		_tmp49_ = _tmp48_->message;
#line 196 "Utility/FileItem.vala"
		tee_jee_logging_log_error (_tmp49_, FALSE, FALSE);
#line 114 "Utility/FileItem.vala"
		_g_error_free0 (e);
#line 639 "FileItem.c"
	}
	__finally0:
#line 114 "Utility/FileItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "Utility/FileItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "Utility/FileItem.vala"
		g_clear_error (&_inner_error0_);
#line 114 "Utility/FileItem.vala"
		return;
#line 650 "FileItem.c"
	}
}

void
file_item_query_file_info_basic (FileItem* self)
{
	GError* _inner_error0_ = NULL;
#line 200 "Utility/FileItem.vala"
	g_return_if_fail (self != NULL);
#line 660 "FileItem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
#line 204 "Utility/FileItem.vala"
		_tmp0_ = self->file_path;
#line 204 "Utility/FileItem.vala"
		_tmp1_ = g_file_parse_name (_tmp0_);
#line 204 "Utility/FileItem.vala"
		file = _tmp1_;
#line 206 "Utility/FileItem.vala"
		_tmp2_ = file;
#line 206 "Utility/FileItem.vala"
		if (g_file_query_exists (_tmp2_, NULL)) {
#line 677 "FileItem.c"
			GFileInfo* _tmp3_ = NULL;
			GFile* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GIcon* _tmp11_;
			GIcon* _tmp12_;
			GFileInfo* _tmp13_;
#line 210 "Utility/FileItem.vala"
			_tmp4_ = file;
#line 210 "Utility/FileItem.vala"
			_tmp5_ = g_strdup_printf ("%s,%s", G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_ATTRIBUTE_STANDARD_ICON);
#line 210 "Utility/FileItem.vala"
			_tmp6_ = _tmp5_;
#line 210 "Utility/FileItem.vala"
			_tmp7_ = g_file_query_info (_tmp4_, _tmp6_, 0, NULL, &_inner_error0_);
#line 210 "Utility/FileItem.vala"
			_tmp8_ = _tmp7_;
#line 210 "Utility/FileItem.vala"
			_g_free0 (_tmp6_);
#line 210 "Utility/FileItem.vala"
			_tmp3_ = _tmp8_;
#line 210 "Utility/FileItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 210 "Utility/FileItem.vala"
				_g_object_unref0 (file);
#line 210 "Utility/FileItem.vala"
				_g_object_unref0 (info);
#line 709 "FileItem.c"
				goto __catch0_g_error;
			}
#line 210 "Utility/FileItem.vala"
			_tmp9_ = _tmp3_;
#line 210 "Utility/FileItem.vala"
			_tmp3_ = NULL;
#line 210 "Utility/FileItem.vala"
			_g_object_unref0 (info);
#line 210 "Utility/FileItem.vala"
			info = _tmp9_;
#line 215 "Utility/FileItem.vala"
			_tmp10_ = info;
#line 215 "Utility/FileItem.vala"
			_tmp11_ = g_file_info_get_icon (_tmp10_);
#line 215 "Utility/FileItem.vala"
			_tmp12_ = _g_object_ref0 (_tmp11_);
#line 215 "Utility/FileItem.vala"
			_g_object_unref0 (self->icon);
#line 215 "Utility/FileItem.vala"
			self->icon = _tmp12_;
#line 217 "Utility/FileItem.vala"
			_tmp13_ = info;
#line 217 "Utility/FileItem.vala"
			self->file_type = g_file_info_get_file_type (_tmp13_);
#line 206 "Utility/FileItem.vala"
			_g_object_unref0 (_tmp3_);
#line 736 "FileItem.c"
		}
#line 202 "Utility/FileItem.vala"
		_g_object_unref0 (file);
#line 202 "Utility/FileItem.vala"
		_g_object_unref0 (info);
#line 742 "FileItem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 202 "Utility/FileItem.vala"
		e = _inner_error0_;
#line 202 "Utility/FileItem.vala"
		_inner_error0_ = NULL;
#line 221 "Utility/FileItem.vala"
		_tmp14_ = e;
#line 221 "Utility/FileItem.vala"
		_tmp15_ = _tmp14_->message;
#line 221 "Utility/FileItem.vala"
		tee_jee_logging_log_error (_tmp15_, FALSE, FALSE);
#line 202 "Utility/FileItem.vala"
		_g_error_free0 (e);
#line 762 "FileItem.c"
	}
	__finally0:
#line 202 "Utility/FileItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "Utility/FileItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "Utility/FileItem.vala"
		g_clear_error (&_inner_error0_);
#line 202 "Utility/FileItem.vala"
		return;
#line 773 "FileItem.c"
	}
}

GdkPixbuf*
file_item_get_icon (FileItem* self,
                    gint icon_size,
                    gboolean add_transparency,
                    gboolean add_emblems)
{
	GdkPixbuf* pixbuf = NULL;
	GIcon* _tmp0_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* result = NULL;
#line 227 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 229 "Utility/FileItem.vala"
	pixbuf = NULL;
#line 231 "Utility/FileItem.vala"
	_tmp0_ = self->icon;
#line 231 "Utility/FileItem.vala"
	if (_tmp0_ != NULL) {
#line 795 "FileItem.c"
		GIcon* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 232 "Utility/FileItem.vala"
		_tmp1_ = self->icon;
#line 232 "Utility/FileItem.vala"
		_tmp2_ = icon_manager_lookup_gicon (_tmp1_, icon_size);
#line 232 "Utility/FileItem.vala"
		_g_object_unref0 (pixbuf);
#line 232 "Utility/FileItem.vala"
		pixbuf = _tmp2_;
#line 806 "FileItem.c"
	}
#line 235 "Utility/FileItem.vala"
	_tmp3_ = pixbuf;
#line 235 "Utility/FileItem.vala"
	if (_tmp3_ == NULL) {
#line 812 "FileItem.c"
		GFileType _tmp4_;
#line 236 "Utility/FileItem.vala"
		_tmp4_ = self->file_type;
#line 236 "Utility/FileItem.vala"
		if (_tmp4_ == G_FILE_TYPE_DIRECTORY) {
#line 818 "FileItem.c"
			GdkPixbuf* _tmp5_;
#line 237 "Utility/FileItem.vala"
			_tmp5_ = icon_manager_lookup ("folder", icon_size, FALSE, FALSE, 1);
#line 237 "Utility/FileItem.vala"
			_g_object_unref0 (pixbuf);
#line 237 "Utility/FileItem.vala"
			pixbuf = _tmp5_;
#line 826 "FileItem.c"
		} else {
			GdkPixbuf* _tmp6_;
#line 240 "Utility/FileItem.vala"
			_tmp6_ = icon_manager_lookup ("text-x-preview", icon_size, FALSE, FALSE, 1);
#line 240 "Utility/FileItem.vala"
			_g_object_unref0 (pixbuf);
#line 240 "Utility/FileItem.vala"
			pixbuf = _tmp6_;
#line 835 "FileItem.c"
		}
	}
#line 244 "Utility/FileItem.vala"
	result = pixbuf;
#line 244 "Utility/FileItem.vala"
	return result;
#line 842 "FileItem.c"
}

gint64
file_item_get_size (FileItem* self)
{
	gint64 result;
#line 84 "Utility/FileItem.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 85 "Utility/FileItem.vala"
	result = self->priv->_size;
#line 85 "Utility/FileItem.vala"
	return result;
#line 855 "FileItem.c"
}

static void
file_item_class_init (FileItemClass * klass,
                      gpointer klass_data)
{
#line 37 "Utility/FileItem.vala"
	file_item_parent_class = g_type_class_peek_parent (klass);
#line 37 "Utility/FileItem.vala"
	g_type_class_adjust_private_offset (klass, &FileItem_private_offset);
#line 37 "Utility/FileItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_file_item_get_property;
#line 37 "Utility/FileItem.vala"
	G_OBJECT_CLASS (klass)->finalize = file_item_finalize;
#line 37 "Utility/FileItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_ITEM_SIZE_PROPERTY, file_item_properties[FILE_ITEM_SIZE_PROPERTY] = g_param_spec_int64 ("size", "size", "size", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 872 "FileItem.c"
}

static void
file_item_gee_comparable_interface_init (GeeComparableIface * iface,
                                         gpointer iface_data)
{
#line 37 "Utility/FileItem.vala"
	file_item_gee_comparable_parent_iface = g_type_interface_peek_parent (iface);
#line 37 "Utility/FileItem.vala"
	iface->compare_to = (gint (*) (GeeComparable*, gconstpointer)) file_item_real_compare_to;
#line 883 "FileItem.c"
}

static void
file_item_instance_init (FileItem * self,
                         gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 37 "Utility/FileItem.vala"
	self->priv = file_item_get_instance_private (self);
#line 39 "Utility/FileItem.vala"
	_tmp0_ = g_strdup ("");
#line 39 "Utility/FileItem.vala"
	self->file_name = _tmp0_;
#line 40 "Utility/FileItem.vala"
	_tmp1_ = g_strdup ("");
#line 40 "Utility/FileItem.vala"
	self->file_location = _tmp1_;
#line 41 "Utility/FileItem.vala"
	_tmp2_ = g_strdup ("");
#line 41 "Utility/FileItem.vala"
	self->file_path = _tmp2_;
#line 42 "Utility/FileItem.vala"
	_tmp3_ = g_strdup ("");
#line 42 "Utility/FileItem.vala"
	self->file_path_prefix = _tmp3_;
#line 43 "Utility/FileItem.vala"
	self->file_type = G_FILE_TYPE_REGULAR;
#line 45 "Utility/FileItem.vala"
	_tmp4_ = g_strdup ("");
#line 45 "Utility/FileItem.vala"
	self->permissions = _tmp4_;
#line 46 "Utility/FileItem.vala"
	_tmp5_ = g_strdup ("");
#line 46 "Utility/FileItem.vala"
	self->owner_user = _tmp5_;
#line 47 "Utility/FileItem.vala"
	_tmp6_ = g_strdup ("");
#line 47 "Utility/FileItem.vala"
	self->owner_group = _tmp6_;
#line 48 "Utility/FileItem.vala"
	_tmp7_ = g_strdup ("");
#line 48 "Utility/FileItem.vala"
	self->content_type = _tmp7_;
#line 49 "Utility/FileItem.vala"
	_tmp8_ = g_strdup ("");
#line 49 "Utility/FileItem.vala"
	self->file_status = _tmp8_;
#line 51 "Utility/FileItem.vala"
	self->is_selected = FALSE;
#line 52 "Utility/FileItem.vala"
	self->is_symlink = FALSE;
#line 53 "Utility/FileItem.vala"
	_tmp9_ = g_strdup ("");
#line 53 "Utility/FileItem.vala"
	self->symlink_target = _tmp9_;
#line 55 "Utility/FileItem.vala"
	self->file_count = (glong) 0;
#line 56 "Utility/FileItem.vala"
	self->dir_count = (glong) 0;
#line 57 "Utility/FileItem.vala"
	self->priv->_size = (gint64) 0;
#line 954 "FileItem.c"
}

static void
file_item_finalize (GObject * obj)
{
	FileItem * self;
#line 37 "Utility/FileItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_ITEM, FileItem);
#line 39 "Utility/FileItem.vala"
	_g_free0 (self->file_name);
#line 40 "Utility/FileItem.vala"
	_g_free0 (self->file_location);
#line 41 "Utility/FileItem.vala"
	_g_free0 (self->file_path);
#line 42 "Utility/FileItem.vala"
	_g_free0 (self->file_path_prefix);
#line 44 "Utility/FileItem.vala"
	_g_date_time_unref0 (self->modified);
#line 45 "Utility/FileItem.vala"
	_g_free0 (self->permissions);
#line 46 "Utility/FileItem.vala"
	_g_free0 (self->owner_user);
#line 47 "Utility/FileItem.vala"
	_g_free0 (self->owner_group);
#line 48 "Utility/FileItem.vala"
	_g_free0 (self->content_type);
#line 49 "Utility/FileItem.vala"
	_g_free0 (self->file_status);
#line 53 "Utility/FileItem.vala"
	_g_free0 (self->symlink_target);
#line 59 "Utility/FileItem.vala"
	_g_object_unref0 (self->icon);
#line 37 "Utility/FileItem.vala"
	G_OBJECT_CLASS (file_item_parent_class)->finalize (obj);
#line 989 "FileItem.c"
}

static GType
file_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FileItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileItem), 0, (GInstanceInitFunc) file_item_instance_init, NULL };
	static const GInterfaceInfo gee_comparable_info = { (GInterfaceInitFunc) file_item_gee_comparable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType file_item_type_id;
	file_item_type_id = g_type_register_static (G_TYPE_OBJECT, "FileItem", &g_define_type_info, 0);
	g_type_add_interface_static (file_item_type_id, GEE_TYPE_COMPARABLE, &gee_comparable_info);
	FileItem_private_offset = g_type_add_instance_private (file_item_type_id, sizeof (FileItemPrivate));
	return file_item_type_id;
}

GType
file_item_get_type (void)
{
	static volatile gsize file_item_type_id__volatile = 0;
	if (g_once_init_enter (&file_item_type_id__volatile)) {
		GType file_item_type_id;
		file_item_type_id = file_item_get_type_once ();
		g_once_init_leave (&file_item_type_id__volatile, file_item_type_id);
	}
	return file_item_type_id__volatile;
}

static void
_vala_file_item_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	FileItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_ITEM, FileItem);
#line 37 "Utility/FileItem.vala"
	switch (property_id) {
#line 37 "Utility/FileItem.vala"
		case FILE_ITEM_SIZE_PROPERTY:
#line 37 "Utility/FileItem.vala"
		g_value_set_int64 (value, file_item_get_size (self));
#line 37 "Utility/FileItem.vala"
		break;
#line 1032 "FileItem.c"
		default:
#line 37 "Utility/FileItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "Utility/FileItem.vala"
		break;
#line 1038 "FileItem.c"
	}
}

