/* RsyncSpaceCheckTask.c generated by valac 0.48.19, the Vala compiler
 * generated from RsyncSpaceCheckTask.vala, do not modify */

/*
 * RsyncTask.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define TYPE_ASYNC_TASK (async_task_get_type ())
#define ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASYNC_TASK, AsyncTask))
#define ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASYNC_TASK, AsyncTaskClass))
#define IS_ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASYNC_TASK))
#define IS_ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASYNC_TASK))
#define ASYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASYNC_TASK, AsyncTaskClass))

typedef struct _AsyncTask AsyncTask;
typedef struct _AsyncTaskClass AsyncTaskClass;
typedef struct _AsyncTaskPrivate AsyncTaskPrivate;
typedef enum  {
	APP_STATUS_NOT_STARTED,
	APP_STATUS_RUNNING,
	APP_STATUS_PAUSED,
	APP_STATUS_FINISHED,
	APP_STATUS_CANCELLED,
	APP_STATUS_PASSWORD_REQUIRED
} AppStatus;

#define TYPE_APP_STATUS (app_status_get_type ())

#define TYPE_RSYNC_SPACE_CHECK_TASK (rsync_space_check_task_get_type ())
#define RSYNC_SPACE_CHECK_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RSYNC_SPACE_CHECK_TASK, RsyncSpaceCheckTask))
#define RSYNC_SPACE_CHECK_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RSYNC_SPACE_CHECK_TASK, RsyncSpaceCheckTaskClass))
#define IS_RSYNC_SPACE_CHECK_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RSYNC_SPACE_CHECK_TASK))
#define IS_RSYNC_SPACE_CHECK_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RSYNC_SPACE_CHECK_TASK))
#define RSYNC_SPACE_CHECK_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RSYNC_SPACE_CHECK_TASK, RsyncSpaceCheckTaskClass))

typedef struct _RsyncSpaceCheckTask RsyncSpaceCheckTask;
typedef struct _RsyncSpaceCheckTaskClass RsyncSpaceCheckTaskClass;
typedef struct _RsyncSpaceCheckTaskPrivate RsyncSpaceCheckTaskPrivate;
enum  {
	RSYNC_SPACE_CHECK_TASK_0_PROPERTY,
	RSYNC_SPACE_CHECK_TASK_NUM_PROPERTIES
};
static GParamSpec* rsync_space_check_task_properties[RSYNC_SPACE_CHECK_TASK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AsyncTask {
	GObject parent_instance;
	AsyncTaskPrivate * priv;
	GDataOutputStream* dos_log;
	gboolean is_terminated;
	GPid child_pid;
	gchar* script_file;
	gchar* working_dir;
	gchar* log_file;
	gboolean background_mode;
	AppStatus status;
	gchar* status_line;
	gint exit_code;
	gchar* error_msg;
	GTimer* timer;
	gdouble progress;
	gdouble percent;
	gint64 prg_count;
	gint64 prg_count_total;
	gint64 prg_bytes;
	gint64 prg_bytes_total;
	gchar* eta;
};

struct _AsyncTaskClass {
	GObjectClass parent_class;
	void (*parse_stdout_line) (AsyncTask* self, const gchar* out_line);
	void (*parse_stderr_line) (AsyncTask* self, const gchar* err_line);
	void (*finish_task) (AsyncTask* self);
};

struct _RsyncSpaceCheckTask {
	AsyncTask parent_instance;
	RsyncSpaceCheckTaskPrivate * priv;
	gboolean delete_extra;
	gboolean delete_after;
	gboolean delete_excluded;
	gboolean relative;
	gchar* exclude_from_file;
	gchar* link_from_path;
	gchar* source_path;
	gchar* dest_path;
	gboolean verbose;
	gboolean io_nice;
	gboolean dry_run;
	gint64 status_line_count;
	gint64 total_size;
};

struct _RsyncSpaceCheckTaskClass {
	AsyncTaskClass parent_class;
};

struct _RsyncSpaceCheckTaskPrivate {
	GRegex* sent_bytes_regex;
};

static gint RsyncSpaceCheckTask_private_offset;
static gpointer rsync_space_check_task_parent_class = NULL;

GType async_task_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AsyncTask, g_object_unref)
GType app_status_get_type (void) G_GNUC_CONST;
GType rsync_space_check_task_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RsyncSpaceCheckTask, g_object_unref)
void async_task_parse_stdout_line (AsyncTask* self,
                                   const gchar* out_line);
void async_task_parse_stderr_line (AsyncTask* self,
                                   const gchar* err_line);
void async_task_finish_task (AsyncTask* self);
RsyncSpaceCheckTask* rsync_space_check_task_new (void);
RsyncSpaceCheckTask* rsync_space_check_task_construct (GType object_type);
AsyncTask* async_task_construct (GType object_type);
static void rsync_space_check_task_init_regular_expressions (RsyncSpaceCheckTask* self);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
void rsync_space_check_task_prepare (RsyncSpaceCheckTask* self);
static gchar* rsync_space_check_task_build_script (RsyncSpaceCheckTask* self);
void tee_jee_logging_log_debug (const gchar* message);
gchar* tee_jee_process_helper_save_bash_script_temp (const gchar* commands,
                                                     const gchar* script_path,
                                                     gboolean force_locale,
                                                     gboolean supress_errors);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gchar* tee_jee_file_system_remove_trailing_slash (const gchar* path);
void rsync_space_check_task_execute (RsyncSpaceCheckTask* self);
gboolean async_task_begin (AsyncTask* self);
static void rsync_space_check_task_real_parse_stdout_line (AsyncTask* base,
                                                    const gchar* out_line);
gboolean rsync_space_check_task_update_progress_parse_console_output (RsyncSpaceCheckTask* self,
                                                                      const gchar* line);
static void rsync_space_check_task_real_parse_stderr_line (AsyncTask* base,
                                                    const gchar* err_line);
static void rsync_space_check_task_real_finish_task (AsyncTask* base);
gint rsync_space_check_task_read_status (RsyncSpaceCheckTask* self);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
static void rsync_space_check_task_finalize (GObject * obj);
static GType rsync_space_check_task_get_type_once (void);

static inline gpointer
rsync_space_check_task_get_instance_private (RsyncSpaceCheckTask* self)
{
	return G_STRUCT_MEMBER_P (self, RsyncSpaceCheckTask_private_offset);
}

RsyncSpaceCheckTask*
rsync_space_check_task_construct (GType object_type)
{
	RsyncSpaceCheckTask * self = NULL;
#line 54 "Utility/RsyncSpaceCheckTask.vala"
	self = (RsyncSpaceCheckTask*) async_task_construct (object_type);
#line 55 "Utility/RsyncSpaceCheckTask.vala"
	rsync_space_check_task_init_regular_expressions (self);
#line 54 "Utility/RsyncSpaceCheckTask.vala"
	return self;
#line 194 "RsyncSpaceCheckTask.c"
}

RsyncSpaceCheckTask*
rsync_space_check_task_new (void)
{
#line 54 "Utility/RsyncSpaceCheckTask.vala"
	return rsync_space_check_task_construct (TYPE_RSYNC_SPACE_CHECK_TASK);
#line 202 "RsyncSpaceCheckTask.c"
}

static void
rsync_space_check_task_init_regular_expressions (RsyncSpaceCheckTask* self)
{
	GRegex* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 58 "Utility/RsyncSpaceCheckTask.vala"
	g_return_if_fail (self != NULL);
#line 59 "Utility/RsyncSpaceCheckTask.vala"
	_tmp0_ = self->priv->sent_bytes_regex;
#line 59 "Utility/RsyncSpaceCheckTask.vala"
	if (_tmp0_ != NULL) {
#line 60 "Utility/RsyncSpaceCheckTask.vala"
		return;
#line 218 "RsyncSpaceCheckTask.c"
	}
	{
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
#line 64 "Utility/RsyncSpaceCheckTask.vala"
		_tmp2_ = g_regex_new ("sent ([0-9,]+)[ \\t]+bytes[ \\t]+received", 0, 0, &_inner_error0_);
#line 64 "Utility/RsyncSpaceCheckTask.vala"
		_tmp1_ = _tmp2_;
#line 64 "Utility/RsyncSpaceCheckTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "RsyncSpaceCheckTask.c"
			goto __catch0_g_error;
		}
#line 64 "Utility/RsyncSpaceCheckTask.vala"
		_tmp3_ = _tmp1_;
#line 64 "Utility/RsyncSpaceCheckTask.vala"
		_tmp1_ = NULL;
#line 64 "Utility/RsyncSpaceCheckTask.vala"
		_g_regex_unref0 (self->priv->sent_bytes_regex);
#line 64 "Utility/RsyncSpaceCheckTask.vala"
		self->priv->sent_bytes_regex = _tmp3_;
#line 63 "Utility/RsyncSpaceCheckTask.vala"
		_g_regex_unref0 (_tmp1_);
#line 243 "RsyncSpaceCheckTask.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 63 "Utility/RsyncSpaceCheckTask.vala"
		e = _inner_error0_;
#line 63 "Utility/RsyncSpaceCheckTask.vala"
		_inner_error0_ = NULL;
#line 67 "Utility/RsyncSpaceCheckTask.vala"
		_tmp4_ = e;
#line 67 "Utility/RsyncSpaceCheckTask.vala"
		_tmp5_ = _tmp4_->message;
#line 67 "Utility/RsyncSpaceCheckTask.vala"
		tee_jee_logging_log_error (_tmp5_, FALSE, FALSE);
#line 63 "Utility/RsyncSpaceCheckTask.vala"
		_g_error_free0 (e);
#line 263 "RsyncSpaceCheckTask.c"
	}
	__finally0:
#line 63 "Utility/RsyncSpaceCheckTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "Utility/RsyncSpaceCheckTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "Utility/RsyncSpaceCheckTask.vala"
		g_clear_error (&_inner_error0_);
#line 63 "Utility/RsyncSpaceCheckTask.vala"
		return;
#line 274 "RsyncSpaceCheckTask.c"
	}
}

void
rsync_space_check_task_prepare (RsyncSpaceCheckTask* self)
{
	gchar* script_text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 71 "Utility/RsyncSpaceCheckTask.vala"
	g_return_if_fail (self != NULL);
#line 72 "Utility/RsyncSpaceCheckTask.vala"
	_tmp0_ = rsync_space_check_task_build_script (self);
#line 72 "Utility/RsyncSpaceCheckTask.vala"
	script_text = _tmp0_;
#line 74 "Utility/RsyncSpaceCheckTask.vala"
	tee_jee_logging_log_debug (script_text);
#line 76 "Utility/RsyncSpaceCheckTask.vala"
	_tmp1_ = ((AsyncTask*) self)->script_file;
#line 76 "Utility/RsyncSpaceCheckTask.vala"
	_tmp2_ = tee_jee_process_helper_save_bash_script_temp (script_text, _tmp1_, TRUE, FALSE);
#line 76 "Utility/RsyncSpaceCheckTask.vala"
	_tmp3_ = _tmp2_;
#line 76 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (_tmp3_);
#line 77 "Utility/RsyncSpaceCheckTask.vala"
	_tmp4_ = ((AsyncTask*) self)->script_file;
#line 77 "Utility/RsyncSpaceCheckTask.vala"
	_tmp5_ = g_strdup_printf ("RsyncSpaceCheckTask:prepare(): saved: %s", _tmp4_);
#line 77 "Utility/RsyncSpaceCheckTask.vala"
	_tmp6_ = _tmp5_;
#line 77 "Utility/RsyncSpaceCheckTask.vala"
	tee_jee_logging_log_debug (_tmp6_);
#line 77 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (_tmp6_);
#line 79 "Utility/RsyncSpaceCheckTask.vala"
	self->total_size = (gint64) 0;
#line 80 "Utility/RsyncSpaceCheckTask.vala"
	self->status_line_count = (gint64) 0;
#line 71 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (script_text);
#line 321 "RsyncSpaceCheckTask.c"
}

static gchar*
rsync_space_check_task_build_script (RsyncSpaceCheckTask* self)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	const gchar* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	const gchar* _tmp60_;
	const gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	gchar* result = NULL;
#line 83 "Utility/RsyncSpaceCheckTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "Utility/RsyncSpaceCheckTask.vala"
	_tmp0_ = g_strdup ("export LC_ALL=C.UTF-8\n");
#line 84 "Utility/RsyncSpaceCheckTask.vala"
	cmd = _tmp0_;
#line 86 "Utility/RsyncSpaceCheckTask.vala"
	_tmp1_ = cmd;
#line 86 "Utility/RsyncSpaceCheckTask.vala"
	_tmp2_ = g_strconcat (_tmp1_, "rsync -aii", NULL);
#line 86 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (cmd);
#line 86 "Utility/RsyncSpaceCheckTask.vala"
	cmd = _tmp2_;
#line 88 "Utility/RsyncSpaceCheckTask.vala"
	_tmp3_ = cmd;
#line 88 "Utility/RsyncSpaceCheckTask.vala"
	_tmp4_ = g_strconcat (_tmp3_, " --recursive", NULL);
#line 88 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (cmd);
#line 88 "Utility/RsyncSpaceCheckTask.vala"
	cmd = _tmp4_;
#line 90 "Utility/RsyncSpaceCheckTask.vala"
	if (self->verbose) {
#line 390 "RsyncSpaceCheckTask.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 91 "Utility/RsyncSpaceCheckTask.vala"
		_tmp5_ = cmd;
#line 91 "Utility/RsyncSpaceCheckTask.vala"
		_tmp6_ = g_strconcat (_tmp5_, " --verbose", NULL);
#line 91 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (cmd);
#line 91 "Utility/RsyncSpaceCheckTask.vala"
		cmd = _tmp6_;
#line 401 "RsyncSpaceCheckTask.c"
	} else {
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 94 "Utility/RsyncSpaceCheckTask.vala"
		_tmp7_ = cmd;
#line 94 "Utility/RsyncSpaceCheckTask.vala"
		_tmp8_ = g_strconcat (_tmp7_, " --quiet", NULL);
#line 94 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (cmd);
#line 94 "Utility/RsyncSpaceCheckTask.vala"
		cmd = _tmp8_;
#line 413 "RsyncSpaceCheckTask.c"
	}
#line 97 "Utility/RsyncSpaceCheckTask.vala"
	if (self->delete_extra) {
#line 417 "RsyncSpaceCheckTask.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 98 "Utility/RsyncSpaceCheckTask.vala"
		_tmp9_ = cmd;
#line 98 "Utility/RsyncSpaceCheckTask.vala"
		_tmp10_ = g_strconcat (_tmp9_, " --delete", NULL);
#line 98 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (cmd);
#line 98 "Utility/RsyncSpaceCheckTask.vala"
		cmd = _tmp10_;
#line 428 "RsyncSpaceCheckTask.c"
	}
#line 101 "Utility/RsyncSpaceCheckTask.vala"
	if (self->delete_after) {
#line 432 "RsyncSpaceCheckTask.c"
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 102 "Utility/RsyncSpaceCheckTask.vala"
		_tmp11_ = cmd;
#line 102 "Utility/RsyncSpaceCheckTask.vala"
		_tmp12_ = g_strconcat (_tmp11_, " --delete-after", NULL);
#line 102 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (cmd);
#line 102 "Utility/RsyncSpaceCheckTask.vala"
		cmd = _tmp12_;
#line 443 "RsyncSpaceCheckTask.c"
	}
#line 105 "Utility/RsyncSpaceCheckTask.vala"
	_tmp13_ = cmd;
#line 105 "Utility/RsyncSpaceCheckTask.vala"
	_tmp14_ = g_strconcat (_tmp13_, " --force", NULL);
#line 105 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (cmd);
#line 105 "Utility/RsyncSpaceCheckTask.vala"
	cmd = _tmp14_;
#line 107 "Utility/RsyncSpaceCheckTask.vala"
	_tmp15_ = cmd;
#line 107 "Utility/RsyncSpaceCheckTask.vala"
	_tmp16_ = g_strconcat (_tmp15_, " --stats", NULL);
#line 107 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (cmd);
#line 107 "Utility/RsyncSpaceCheckTask.vala"
	cmd = _tmp16_;
#line 109 "Utility/RsyncSpaceCheckTask.vala"
	_tmp17_ = cmd;
#line 109 "Utility/RsyncSpaceCheckTask.vala"
	_tmp18_ = g_strconcat (_tmp17_, " --sparse", NULL);
#line 109 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (cmd);
#line 109 "Utility/RsyncSpaceCheckTask.vala"
	cmd = _tmp18_;
#line 111 "Utility/RsyncSpaceCheckTask.vala"
	if (self->delete_excluded) {
#line 471 "RsyncSpaceCheckTask.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 112 "Utility/RsyncSpaceCheckTask.vala"
		_tmp19_ = cmd;
#line 112 "Utility/RsyncSpaceCheckTask.vala"
		_tmp20_ = g_strconcat (_tmp19_, " --delete-excluded", NULL);
#line 112 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (cmd);
#line 112 "Utility/RsyncSpaceCheckTask.vala"
		cmd = _tmp20_;
#line 482 "RsyncSpaceCheckTask.c"
	}
#line 115 "Utility/RsyncSpaceCheckTask.vala"
	_tmp21_ = cmd;
#line 115 "Utility/RsyncSpaceCheckTask.vala"
	_tmp22_ = g_strconcat (_tmp21_, " --dry-run", NULL);
#line 115 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (cmd);
#line 115 "Utility/RsyncSpaceCheckTask.vala"
	cmd = _tmp22_;
#line 117 "Utility/RsyncSpaceCheckTask.vala"
	_tmp23_ = self->link_from_path;
#line 117 "Utility/RsyncSpaceCheckTask.vala"
	_tmp24_ = strlen (_tmp23_);
#line 117 "Utility/RsyncSpaceCheckTask.vala"
	_tmp25_ = _tmp24_;
#line 117 "Utility/RsyncSpaceCheckTask.vala"
	if (_tmp25_ > 0) {
#line 500 "RsyncSpaceCheckTask.c"
		const gchar* _tmp26_;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
#line 118 "Utility/RsyncSpaceCheckTask.vala"
		_tmp26_ = self->link_from_path;
#line 118 "Utility/RsyncSpaceCheckTask.vala"
		if (!g_str_has_suffix (_tmp26_, "/")) {
#line 513 "RsyncSpaceCheckTask.c"
			const gchar* _tmp27_;
			gchar* _tmp28_;
#line 119 "Utility/RsyncSpaceCheckTask.vala"
			_tmp27_ = self->link_from_path;
#line 119 "Utility/RsyncSpaceCheckTask.vala"
			_tmp28_ = g_strdup_printf ("%s/", _tmp27_);
#line 119 "Utility/RsyncSpaceCheckTask.vala"
			_g_free0 (self->link_from_path);
#line 119 "Utility/RsyncSpaceCheckTask.vala"
			self->link_from_path = _tmp28_;
#line 524 "RsyncSpaceCheckTask.c"
		}
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		_tmp29_ = cmd;
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		_tmp30_ = self->link_from_path;
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		_tmp31_ = tee_jee_file_system_escape_single_quote (_tmp30_);
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		_tmp32_ = _tmp31_;
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		_tmp33_ = g_strdup_printf (" --link-dest='%s'", _tmp32_);
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		_tmp34_ = _tmp33_;
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		_tmp35_ = g_strconcat (_tmp29_, _tmp34_, NULL);
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (cmd);
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		cmd = _tmp35_;
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (_tmp34_);
#line 122 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (_tmp32_);
#line 548 "RsyncSpaceCheckTask.c"
	}
#line 125 "Utility/RsyncSpaceCheckTask.vala"
	_tmp36_ = self->exclude_from_file;
#line 125 "Utility/RsyncSpaceCheckTask.vala"
	_tmp37_ = strlen (_tmp36_);
#line 125 "Utility/RsyncSpaceCheckTask.vala"
	_tmp38_ = _tmp37_;
#line 125 "Utility/RsyncSpaceCheckTask.vala"
	if (_tmp38_ > 0) {
#line 558 "RsyncSpaceCheckTask.c"
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gboolean _tmp46_ = FALSE;
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		_tmp39_ = cmd;
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		_tmp40_ = self->exclude_from_file;
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		_tmp41_ = tee_jee_file_system_escape_single_quote (_tmp40_);
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		_tmp42_ = _tmp41_;
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		_tmp43_ = g_strdup_printf (" --exclude-from='%s'", _tmp42_);
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		_tmp44_ = _tmp43_;
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		_tmp45_ = g_strconcat (_tmp39_, _tmp44_, NULL);
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (cmd);
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		cmd = _tmp45_;
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (_tmp44_);
#line 126 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (_tmp42_);
#line 128 "Utility/RsyncSpaceCheckTask.vala"
		if (self->delete_extra) {
#line 128 "Utility/RsyncSpaceCheckTask.vala"
			_tmp46_ = self->delete_excluded;
#line 593 "RsyncSpaceCheckTask.c"
		} else {
#line 128 "Utility/RsyncSpaceCheckTask.vala"
			_tmp46_ = FALSE;
#line 597 "RsyncSpaceCheckTask.c"
		}
#line 128 "Utility/RsyncSpaceCheckTask.vala"
		if (_tmp46_) {
#line 601 "RsyncSpaceCheckTask.c"
			const gchar* _tmp47_;
			gchar* _tmp48_;
#line 129 "Utility/RsyncSpaceCheckTask.vala"
			_tmp47_ = cmd;
#line 129 "Utility/RsyncSpaceCheckTask.vala"
			_tmp48_ = g_strconcat (_tmp47_, " --delete-excluded", NULL);
#line 129 "Utility/RsyncSpaceCheckTask.vala"
			_g_free0 (cmd);
#line 129 "Utility/RsyncSpaceCheckTask.vala"
			cmd = _tmp48_;
#line 612 "RsyncSpaceCheckTask.c"
		}
	}
#line 133 "Utility/RsyncSpaceCheckTask.vala"
	_tmp49_ = self->source_path;
#line 133 "Utility/RsyncSpaceCheckTask.vala"
	_tmp50_ = tee_jee_file_system_remove_trailing_slash (_tmp49_);
#line 133 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (self->source_path);
#line 133 "Utility/RsyncSpaceCheckTask.vala"
	self->source_path = _tmp50_;
#line 135 "Utility/RsyncSpaceCheckTask.vala"
	_tmp51_ = self->dest_path;
#line 135 "Utility/RsyncSpaceCheckTask.vala"
	_tmp52_ = tee_jee_file_system_remove_trailing_slash (_tmp51_);
#line 135 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (self->dest_path);
#line 135 "Utility/RsyncSpaceCheckTask.vala"
	self->dest_path = _tmp52_;
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	_tmp53_ = cmd;
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	_tmp54_ = self->source_path;
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	_tmp55_ = tee_jee_file_system_escape_single_quote (_tmp54_);
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	_tmp56_ = _tmp55_;
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	_tmp57_ = g_strdup_printf (" '%s/'", _tmp56_);
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	_tmp58_ = _tmp57_;
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	_tmp59_ = g_strconcat (_tmp53_, _tmp58_, NULL);
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (cmd);
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	cmd = _tmp59_;
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (_tmp58_);
#line 137 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (_tmp56_);
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	_tmp60_ = cmd;
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	_tmp61_ = self->dest_path;
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	_tmp62_ = tee_jee_file_system_escape_single_quote (_tmp61_);
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	_tmp63_ = _tmp62_;
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	_tmp64_ = g_strdup_printf (" '%s/'", _tmp63_);
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	_tmp65_ = _tmp64_;
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	_tmp66_ = g_strconcat (_tmp60_, _tmp65_, NULL);
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (cmd);
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	cmd = _tmp66_;
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (_tmp65_);
#line 139 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (_tmp63_);
#line 141 "Utility/RsyncSpaceCheckTask.vala"
	result = cmd;
#line 141 "Utility/RsyncSpaceCheckTask.vala"
	return result;
#line 679 "RsyncSpaceCheckTask.c"
}

void
rsync_space_check_task_execute (RsyncSpaceCheckTask* self)
{
#line 146 "Utility/RsyncSpaceCheckTask.vala"
	g_return_if_fail (self != NULL);
#line 148 "Utility/RsyncSpaceCheckTask.vala"
	tee_jee_logging_log_debug ("RsyncSpaceCheckTask:execute()");
#line 150 "Utility/RsyncSpaceCheckTask.vala"
	rsync_space_check_task_prepare (self);
#line 151 "Utility/RsyncSpaceCheckTask.vala"
	async_task_begin ((AsyncTask*) self);
#line 693 "RsyncSpaceCheckTask.c"
}

static void
rsync_space_check_task_real_parse_stdout_line (AsyncTask* base,
                                               const gchar* out_line)
{
	RsyncSpaceCheckTask * self;
#line 154 "Utility/RsyncSpaceCheckTask.vala"
	self = (RsyncSpaceCheckTask*) base;
#line 154 "Utility/RsyncSpaceCheckTask.vala"
	g_return_if_fail (out_line != NULL);
#line 155 "Utility/RsyncSpaceCheckTask.vala"
	if (((AsyncTask*) self)->is_terminated) {
#line 156 "Utility/RsyncSpaceCheckTask.vala"
		return;
#line 709 "RsyncSpaceCheckTask.c"
	}
#line 159 "Utility/RsyncSpaceCheckTask.vala"
	rsync_space_check_task_update_progress_parse_console_output (self, out_line);
#line 713 "RsyncSpaceCheckTask.c"
}

static void
rsync_space_check_task_real_parse_stderr_line (AsyncTask* base,
                                               const gchar* err_line)
{
	RsyncSpaceCheckTask * self;
#line 162 "Utility/RsyncSpaceCheckTask.vala"
	self = (RsyncSpaceCheckTask*) base;
#line 162 "Utility/RsyncSpaceCheckTask.vala"
	g_return_if_fail (err_line != NULL);
#line 163 "Utility/RsyncSpaceCheckTask.vala"
	if (((AsyncTask*) self)->is_terminated) {
#line 164 "Utility/RsyncSpaceCheckTask.vala"
		return;
#line 729 "RsyncSpaceCheckTask.c"
	}
#line 167 "Utility/RsyncSpaceCheckTask.vala"
	rsync_space_check_task_update_progress_parse_console_output (self, err_line);
#line 733 "RsyncSpaceCheckTask.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result = 0LL;
#line 770 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 771 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 771 "glib-2.0.vapi"
	return result;
#line 747 "RsyncSpaceCheckTask.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 769 "RsyncSpaceCheckTask.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 773 "RsyncSpaceCheckTask.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 779 "RsyncSpaceCheckTask.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 783 "RsyncSpaceCheckTask.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 787 "RsyncSpaceCheckTask.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 795 "RsyncSpaceCheckTask.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			_g_free0 (_tmp7_);
#line 1539 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 827 "RsyncSpaceCheckTask.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 836 "RsyncSpaceCheckTask.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 852 "RsyncSpaceCheckTask.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 861 "RsyncSpaceCheckTask.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 875 "RsyncSpaceCheckTask.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 884 "RsyncSpaceCheckTask.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 893 "RsyncSpaceCheckTask.c"
}

gboolean
rsync_space_check_task_update_progress_parse_console_output (RsyncSpaceCheckTask* self,
                                                             const gchar* line)
{
	gboolean _tmp0_ = FALSE;
	gint64 _tmp3_;
	GMatchInfo* match = NULL;
	GRegex* _tmp4_;
	GMatchInfo* _tmp5_ = NULL;
	gboolean _tmp6_;
	gboolean result = FALSE;
#line 170 "Utility/RsyncSpaceCheckTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 170 "Utility/RsyncSpaceCheckTask.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 171 "Utility/RsyncSpaceCheckTask.vala"
	if (line == NULL) {
#line 171 "Utility/RsyncSpaceCheckTask.vala"
		_tmp0_ = TRUE;
#line 915 "RsyncSpaceCheckTask.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 171 "Utility/RsyncSpaceCheckTask.vala"
		_tmp1_ = strlen (line);
#line 171 "Utility/RsyncSpaceCheckTask.vala"
		_tmp2_ = _tmp1_;
#line 171 "Utility/RsyncSpaceCheckTask.vala"
		_tmp0_ = _tmp2_ == 0;
#line 925 "RsyncSpaceCheckTask.c"
	}
#line 171 "Utility/RsyncSpaceCheckTask.vala"
	if (_tmp0_) {
#line 172 "Utility/RsyncSpaceCheckTask.vala"
		result = TRUE;
#line 172 "Utility/RsyncSpaceCheckTask.vala"
		return result;
#line 933 "RsyncSpaceCheckTask.c"
	}
#line 175 "Utility/RsyncSpaceCheckTask.vala"
	_tmp3_ = self->status_line_count;
#line 175 "Utility/RsyncSpaceCheckTask.vala"
	self->status_line_count = _tmp3_ + 1;
#line 177 "Utility/RsyncSpaceCheckTask.vala"
	if (((AsyncTask*) self)->prg_count_total > ((gint64) 0)) {
#line 178 "Utility/RsyncSpaceCheckTask.vala"
		((AsyncTask*) self)->prg_count = self->status_line_count;
#line 179 "Utility/RsyncSpaceCheckTask.vala"
		((AsyncTask*) self)->progress = (((AsyncTask*) self)->prg_count * 1.0) / ((AsyncTask*) self)->prg_count_total;
#line 945 "RsyncSpaceCheckTask.c"
	}
#line 184 "Utility/RsyncSpaceCheckTask.vala"
	_tmp4_ = self->priv->sent_bytes_regex;
#line 184 "Utility/RsyncSpaceCheckTask.vala"
	_tmp6_ = g_regex_match (_tmp4_, line, 0, &_tmp5_);
#line 184 "Utility/RsyncSpaceCheckTask.vala"
	_g_match_info_unref0 (match);
#line 184 "Utility/RsyncSpaceCheckTask.vala"
	match = _tmp5_;
#line 184 "Utility/RsyncSpaceCheckTask.vala"
	if (_tmp6_) {
#line 957 "RsyncSpaceCheckTask.c"
		GMatchInfo* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 185 "Utility/RsyncSpaceCheckTask.vala"
		_tmp7_ = match;
#line 185 "Utility/RsyncSpaceCheckTask.vala"
		_tmp8_ = g_match_info_fetch (_tmp7_, 1);
#line 185 "Utility/RsyncSpaceCheckTask.vala"
		_tmp9_ = _tmp8_;
#line 185 "Utility/RsyncSpaceCheckTask.vala"
		_tmp10_ = string_replace (_tmp9_, ",", "");
#line 185 "Utility/RsyncSpaceCheckTask.vala"
		_tmp11_ = _tmp10_;
#line 185 "Utility/RsyncSpaceCheckTask.vala"
		self->total_size = int64_parse (_tmp11_, (guint) 0);
#line 185 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (_tmp11_);
#line 185 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (_tmp9_);
#line 979 "RsyncSpaceCheckTask.c"
	} else {
	}
#line 191 "Utility/RsyncSpaceCheckTask.vala"
	result = TRUE;
#line 191 "Utility/RsyncSpaceCheckTask.vala"
	_g_match_info_unref0 (match);
#line 191 "Utility/RsyncSpaceCheckTask.vala"
	return result;
#line 988 "RsyncSpaceCheckTask.c"
}

static void
rsync_space_check_task_real_finish_task (AsyncTask* base)
{
	RsyncSpaceCheckTask * self;
	gboolean _tmp0_ = FALSE;
	AppStatus _tmp1_;
#line 194 "Utility/RsyncSpaceCheckTask.vala"
	self = (RsyncSpaceCheckTask*) base;
#line 195 "Utility/RsyncSpaceCheckTask.vala"
	_tmp1_ = ((AsyncTask*) self)->status;
#line 195 "Utility/RsyncSpaceCheckTask.vala"
	if (_tmp1_ != APP_STATUS_CANCELLED) {
#line 1003 "RsyncSpaceCheckTask.c"
		AppStatus _tmp2_;
#line 195 "Utility/RsyncSpaceCheckTask.vala"
		_tmp2_ = ((AsyncTask*) self)->status;
#line 195 "Utility/RsyncSpaceCheckTask.vala"
		_tmp0_ = _tmp2_ != APP_STATUS_PASSWORD_REQUIRED;
#line 1009 "RsyncSpaceCheckTask.c"
	} else {
#line 195 "Utility/RsyncSpaceCheckTask.vala"
		_tmp0_ = FALSE;
#line 1013 "RsyncSpaceCheckTask.c"
	}
#line 195 "Utility/RsyncSpaceCheckTask.vala"
	if (_tmp0_) {
#line 196 "Utility/RsyncSpaceCheckTask.vala"
		((AsyncTask*) self)->status = APP_STATUS_FINISHED;
#line 1019 "RsyncSpaceCheckTask.c"
	}
}

gint
rsync_space_check_task_read_status (RsyncSpaceCheckTask* self)
{
	gchar* status_file = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* f = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gint result = 0;
#line 200 "Utility/RsyncSpaceCheckTask.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 201 "Utility/RsyncSpaceCheckTask.vala"
	_tmp0_ = ((AsyncTask*) self)->working_dir;
#line 201 "Utility/RsyncSpaceCheckTask.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/status", NULL);
#line 201 "Utility/RsyncSpaceCheckTask.vala"
	status_file = _tmp1_;
#line 202 "Utility/RsyncSpaceCheckTask.vala"
	_tmp2_ = status_file;
#line 202 "Utility/RsyncSpaceCheckTask.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 202 "Utility/RsyncSpaceCheckTask.vala"
	f = _tmp3_;
#line 203 "Utility/RsyncSpaceCheckTask.vala"
	_tmp4_ = f;
#line 203 "Utility/RsyncSpaceCheckTask.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 1052 "RsyncSpaceCheckTask.c"
		gchar* txt = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 204 "Utility/RsyncSpaceCheckTask.vala"
		_tmp5_ = status_file;
#line 204 "Utility/RsyncSpaceCheckTask.vala"
		_tmp6_ = tee_jee_file_system_file_read (_tmp5_);
#line 204 "Utility/RsyncSpaceCheckTask.vala"
		txt = _tmp6_;
#line 205 "Utility/RsyncSpaceCheckTask.vala"
		_tmp7_ = txt;
#line 205 "Utility/RsyncSpaceCheckTask.vala"
		result = atoi (_tmp7_);
#line 205 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (txt);
#line 205 "Utility/RsyncSpaceCheckTask.vala"
		_g_object_unref0 (f);
#line 205 "Utility/RsyncSpaceCheckTask.vala"
		_g_free0 (status_file);
#line 205 "Utility/RsyncSpaceCheckTask.vala"
		return result;
#line 1075 "RsyncSpaceCheckTask.c"
	}
#line 207 "Utility/RsyncSpaceCheckTask.vala"
	result = -1;
#line 207 "Utility/RsyncSpaceCheckTask.vala"
	_g_object_unref0 (f);
#line 207 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (status_file);
#line 207 "Utility/RsyncSpaceCheckTask.vala"
	return result;
#line 1085 "RsyncSpaceCheckTask.c"
}

static void
rsync_space_check_task_class_init (RsyncSpaceCheckTaskClass * klass,
                                   gpointer klass_data)
{
#line 31 "Utility/RsyncSpaceCheckTask.vala"
	rsync_space_check_task_parent_class = g_type_class_peek_parent (klass);
#line 31 "Utility/RsyncSpaceCheckTask.vala"
	g_type_class_adjust_private_offset (klass, &RsyncSpaceCheckTask_private_offset);
#line 31 "Utility/RsyncSpaceCheckTask.vala"
	((AsyncTaskClass *) klass)->parse_stdout_line = (void (*) (AsyncTask*, const gchar*)) rsync_space_check_task_real_parse_stdout_line;
#line 31 "Utility/RsyncSpaceCheckTask.vala"
	((AsyncTaskClass *) klass)->parse_stderr_line = (void (*) (AsyncTask*, const gchar*)) rsync_space_check_task_real_parse_stderr_line;
#line 31 "Utility/RsyncSpaceCheckTask.vala"
	((AsyncTaskClass *) klass)->finish_task = (void (*) (AsyncTask*)) rsync_space_check_task_real_finish_task;
#line 31 "Utility/RsyncSpaceCheckTask.vala"
	G_OBJECT_CLASS (klass)->finalize = rsync_space_check_task_finalize;
#line 1104 "RsyncSpaceCheckTask.c"
}

static void
rsync_space_check_task_instance_init (RsyncSpaceCheckTask * self,
                                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 31 "Utility/RsyncSpaceCheckTask.vala"
	self->priv = rsync_space_check_task_get_instance_private (self);
#line 34 "Utility/RsyncSpaceCheckTask.vala"
	self->delete_extra = TRUE;
#line 35 "Utility/RsyncSpaceCheckTask.vala"
	self->delete_after = FALSE;
#line 36 "Utility/RsyncSpaceCheckTask.vala"
	self->delete_excluded = FALSE;
#line 37 "Utility/RsyncSpaceCheckTask.vala"
	self->relative = FALSE;
#line 39 "Utility/RsyncSpaceCheckTask.vala"
	_tmp0_ = g_strdup ("");
#line 39 "Utility/RsyncSpaceCheckTask.vala"
	self->exclude_from_file = _tmp0_;
#line 40 "Utility/RsyncSpaceCheckTask.vala"
	_tmp1_ = g_strdup ("");
#line 40 "Utility/RsyncSpaceCheckTask.vala"
	self->link_from_path = _tmp1_;
#line 41 "Utility/RsyncSpaceCheckTask.vala"
	_tmp2_ = g_strdup ("");
#line 41 "Utility/RsyncSpaceCheckTask.vala"
	self->source_path = _tmp2_;
#line 42 "Utility/RsyncSpaceCheckTask.vala"
	_tmp3_ = g_strdup ("");
#line 42 "Utility/RsyncSpaceCheckTask.vala"
	self->dest_path = _tmp3_;
#line 43 "Utility/RsyncSpaceCheckTask.vala"
	self->verbose = TRUE;
#line 44 "Utility/RsyncSpaceCheckTask.vala"
	self->io_nice = TRUE;
#line 45 "Utility/RsyncSpaceCheckTask.vala"
	self->dry_run = FALSE;
#line 51 "Utility/RsyncSpaceCheckTask.vala"
	self->status_line_count = (gint64) 0;
#line 52 "Utility/RsyncSpaceCheckTask.vala"
	self->total_size = (gint64) 0;
#line 1151 "RsyncSpaceCheckTask.c"
}

static void
rsync_space_check_task_finalize (GObject * obj)
{
	RsyncSpaceCheckTask * self;
#line 31 "Utility/RsyncSpaceCheckTask.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RSYNC_SPACE_CHECK_TASK, RsyncSpaceCheckTask);
#line 39 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (self->exclude_from_file);
#line 40 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (self->link_from_path);
#line 41 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (self->source_path);
#line 42 "Utility/RsyncSpaceCheckTask.vala"
	_g_free0 (self->dest_path);
#line 48 "Utility/RsyncSpaceCheckTask.vala"
	_g_regex_unref0 (self->priv->sent_bytes_regex);
#line 31 "Utility/RsyncSpaceCheckTask.vala"
	G_OBJECT_CLASS (rsync_space_check_task_parent_class)->finalize (obj);
#line 1172 "RsyncSpaceCheckTask.c"
}

static GType
rsync_space_check_task_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RsyncSpaceCheckTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rsync_space_check_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RsyncSpaceCheckTask), 0, (GInstanceInitFunc) rsync_space_check_task_instance_init, NULL };
	GType rsync_space_check_task_type_id;
	rsync_space_check_task_type_id = g_type_register_static (TYPE_ASYNC_TASK, "RsyncSpaceCheckTask", &g_define_type_info, 0);
	RsyncSpaceCheckTask_private_offset = g_type_add_instance_private (rsync_space_check_task_type_id, sizeof (RsyncSpaceCheckTaskPrivate));
	return rsync_space_check_task_type_id;
}

GType
rsync_space_check_task_get_type (void)
{
	static volatile gsize rsync_space_check_task_type_id__volatile = 0;
	if (g_once_init_enter (&rsync_space_check_task_type_id__volatile)) {
		GType rsync_space_check_task_type_id;
		rsync_space_check_task_type_id = rsync_space_check_task_get_type_once ();
		g_once_init_leave (&rsync_space_check_task_type_id__volatile, rsync_space_check_task_type_id);
	}
	return rsync_space_check_task_type_id__volatile;
}

